/*******************************************************************************
* File Name: CAN_Tx.h  
* Version 1.90
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_CAN_Tx_H) /* Pins CAN_Tx_H */
#define CY_PINS_CAN_Tx_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "CAN_Tx_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    CAN_Tx_Write(uint8 value) ;
void    CAN_Tx_SetDriveMode(uint8 mode) ;
uint8   CAN_Tx_ReadDataReg(void) ;
uint8   CAN_Tx_Read(void) ;
uint8   CAN_Tx_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define CAN_Tx_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define CAN_Tx_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define CAN_Tx_DM_RES_UP          PIN_DM_RES_UP
#define CAN_Tx_DM_RES_DWN         PIN_DM_RES_DWN
#define CAN_Tx_DM_OD_LO           PIN_DM_OD_LO
#define CAN_Tx_DM_OD_HI           PIN_DM_OD_HI
#define CAN_Tx_DM_STRONG          PIN_DM_STRONG
#define CAN_Tx_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define CAN_Tx_MASK               CAN_Tx__MASK
#define CAN_Tx_SHIFT              CAN_Tx__SHIFT
#define CAN_Tx_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define CAN_Tx_PS                     (* (reg8 *) CAN_Tx__PS)
/* Data Register */
#define CAN_Tx_DR                     (* (reg8 *) CAN_Tx__DR)
/* Port Number */
#define CAN_Tx_PRT_NUM                (* (reg8 *) CAN_Tx__PRT) 
/* Connect to Analog Globals */                                                  
#define CAN_Tx_AG                     (* (reg8 *) CAN_Tx__AG)                       
/* Analog MUX bux enable */
#define CAN_Tx_AMUX                   (* (reg8 *) CAN_Tx__AMUX) 
/* Bidirectional Enable */                                                        
#define CAN_Tx_BIE                    (* (reg8 *) CAN_Tx__BIE)
/* Bit-mask for Aliased Register Access */
#define CAN_Tx_BIT_MASK               (* (reg8 *) CAN_Tx__BIT_MASK)
/* Bypass Enable */
#define CAN_Tx_BYP                    (* (reg8 *) CAN_Tx__BYP)
/* Port wide control signals */                                                   
#define CAN_Tx_CTL                    (* (reg8 *) CAN_Tx__CTL)
/* Drive Modes */
#define CAN_Tx_DM0                    (* (reg8 *) CAN_Tx__DM0) 
#define CAN_Tx_DM1                    (* (reg8 *) CAN_Tx__DM1)
#define CAN_Tx_DM2                    (* (reg8 *) CAN_Tx__DM2) 
/* Input Buffer Disable Override */
#define CAN_Tx_INP_DIS                (* (reg8 *) CAN_Tx__INP_DIS)
/* LCD Common or Segment Drive */
#define CAN_Tx_LCD_COM_SEG            (* (reg8 *) CAN_Tx__LCD_COM_SEG)
/* Enable Segment LCD */
#define CAN_Tx_LCD_EN                 (* (reg8 *) CAN_Tx__LCD_EN)
/* Slew Rate Control */
#define CAN_Tx_SLW                    (* (reg8 *) CAN_Tx__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define CAN_Tx_PRTDSI__CAPS_SEL       (* (reg8 *) CAN_Tx__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define CAN_Tx_PRTDSI__DBL_SYNC_IN    (* (reg8 *) CAN_Tx__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define CAN_Tx_PRTDSI__OE_SEL0        (* (reg8 *) CAN_Tx__PRTDSI__OE_SEL0) 
#define CAN_Tx_PRTDSI__OE_SEL1        (* (reg8 *) CAN_Tx__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define CAN_Tx_PRTDSI__OUT_SEL0       (* (reg8 *) CAN_Tx__PRTDSI__OUT_SEL0) 
#define CAN_Tx_PRTDSI__OUT_SEL1       (* (reg8 *) CAN_Tx__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define CAN_Tx_PRTDSI__SYNC_OUT       (* (reg8 *) CAN_Tx__PRTDSI__SYNC_OUT) 


#if defined(CAN_Tx__INTSTAT)  /* Interrupt Registers */

    #define CAN_Tx_INTSTAT                (* (reg8 *) CAN_Tx__INTSTAT)
    #define CAN_Tx_SNAP                   (* (reg8 *) CAN_Tx__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins CAN_Tx_H */


/* [] END OF FILE */
